<template>
    <nav class="navbar navbar-expand-lg navbar-light bg-white text-white">

        <div v-if="this.$route.path=='/dashboard/'+userName" class="navbar-toggle float-left p-0 m-0 panel-toggler" data-toggle="collapse" data-target="#sidebar" @click="toggleSidebar()">
          <font-awesome-icon class="mx-2 text-secondary rotation" :class="{rotated:rotation==180}"  size="3x" icon="external-link-square-alt"/>
        </div>
           <b-navbar-brand class="ml-2 mr-auto" to="/">
      <b-img
        rounded
        src="@/public/images/favicon.svg"
        width="45px"
        height="45px"
        class="mt-0 mb-0 m-0"
        alt="myreads"
      />
      <b-nav-text class="title ml-2 text-white"><h3> MyReads </h3></b-nav-text>
    </b-navbar-brand>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse ml-lg-auto" id="navbarNav">
          <ul class="navbar-nav ml-lg-auto ">
            <template v-if="!userName">
              <li class="nav-item ">
                <router-link to="/login">
                  <a  class="my-2 my-sm-0 mx-1 p-1 nav-link btn btn-sm btn-secondary text-white  d-flex justify-content-around align-items-center">
                    <font-awesome-icon class="mx-2 text text-white ico" icon="sign-in-alt"/>Login
                  </a>
                </router-link>
              </li>
              <li class="nav-item">
                <router-link to="/register">
                  <a  class="my-2 my-sm-0 mx-1 p-1 nav-link btn btn-sm btn-secondary text-white  d-flex justify-content-around align-items-center">
                    <font-awesome-icon class="mx-1 text text-white ico" icon="edit"/>Register
                  </a>
                </router-link>
              </li>
            </template>
            <template v-else>

              <li class="nav-item dropdown order-lg-0 order-1 " v-if="notifications.length>0">
                <a
                  class="nav-link dropdown-toggle  mx-1 p-1  btn btn-sm btn-secondary text-white  d-flex justify-content-around align-items-center"
                  :class="{disabled:notifications.length==0}"
                  id="navbarDropdown"
                  role="button"
                  data-toggle="dropdown"
                  aria-haspopup="true"
                  aria-expanded="false"
                >
                  <font-awesome-layers class="fa-fw ico">
                    <font-awesome-icon icon="comment-alt" class="p-0" color="white"></font-awesome-icon>
                    <font-awesome-layers
                      class="fa-layers-counter fa-lg fa-layers-top-right"
                    >{{notifications.length}}</font-awesome-layers>
                  </font-awesome-layers>
                  <span class="d-lg-none text-white ml-2 p-0 m-0 invisible">{{userName || 'Guest'}}</span>
                </a>

                <div
                  class="dropdown-menu dropdown-menu-long dropdown-menu-right col-lg-6 col-12"
                  aria-labelledby="navbarDropdown"
                >
                  <div class="list-group">
                    <a
                      class="list-group-item list-group-item-action"
                      v-for="(notification,key) in notifications"
                      :key="key"
                    >
                      <div class="d-flex w-100 justify-content-between">
                        <h5 class="mb-1">Friendship Request from {{notification.sender.name}}</h5>
                        <small>{{since(notification.date)}}</small>
                      </div>
                      <div class="mb-1">
                        <div
                          class="btn-group mt-2 float-right"
                          role="group"
                          aria-label="accep-decline frienship"
                        >
                          <button
                            type="button"
                            @click="resFrienship(notification,true)"
                            class="btn btn-primary btn-sm mr-2"
                          >Accept</button>
                          <button
                            type="button"
                            @click="resFrienship(notification,false)"
                            class="btn btn-danger btn-sm"
                          >Decline</button>
                        </div>
                      </div>
                    </a>
                  </div>
                </div>
              </li>

              <li class="nav-item dropdown order-lg-1 order-0 ">
                <a
                  class="nav-link dropdown-toggle mx-1 p-1 btn btn-sm btn-secondary text-white  d-flex justify-content-around align-items-center"
                  id="navbarDropdown"
                  role="button"
                  data-toggle="dropdown"
                  aria-haspopup="true"
                  aria-expanded="false"
                >
                  <font-awesome-icon icon="user" class=" text-white ico p-0 m-0"/>
                  <span class="text-white ml-2 p-0 m-0">{{userName || 'Guest'}}</span>
                </a>
                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                  <div class="d-flex flex-lg-column">
                    <router-link tag="li" :to="'/dashboard/'+userName">
                      <div class="dropdown-item  btn ">
                        <font-awesome-icon class="icon" icon="home"/> <span class="ml-2">Home</span>
                      </div>
                    </router-link>
                    <router-link tag="li" :to="'/profile/'+userName">
                      <div class="dropdown-item btn ">
                        <font-awesome-icon class="icon" icon="user-edit"/><span class="ml-2">Profile</span>
                      </div>
                    </router-link>
                    <div class="dropdown-divider d-none d-lg-block"></div>
                    <div v-on:click="logoff" class="dropdown-item btn ">
                      <font-awesome-icon class="icon" color="firebrick" icon="sign-out-alt"/><span class="ml-2">LogOff</span>
                    </div>
                  </div>
                </div>
              </li>
            </template>
          </ul>
        </div>
      </nav>

</template>
<script>
import moment from "moment";
import EventBus from "../main";
const $ = require("jquery");
export default {
  name: "navar",
  data() {
    return {
      userName: null,
      user: null,
      notifications: [],
      rotation:0
    };
  },
  created: function() {
    this.$socket.on('logOff',()=>{
      this.logoff()
    })
    this.$socket.on("resNotifications", notifications => {
      notifications.forEach(notification => {
        this.notifications.push({
          sender: notification,
          date: notification.friendship.createdAt
        });
       // console.log(this.notifications.length);
      });
    });
  },
  mounted: function() {
    EventBus.$on(
      "updateUser",
      user=> {
        this.updateUser();
      }
    );
    this.updateUser();
    this.$socket.on("connect", () => {
      this.keepAlive();
    });
    this.$socket.on("reqFriendship", notification => {
      this.$toastr.info(
        "You can accep or decline Frienships request at notification panel, if You acceps the requests" +
          notification.sender.name +
          "can share your libraries",
        "Frienship request from " + notification.sender.name,
        {
          preventDuplicates: true,
          progressBar: true,
          positionClass: 'toast-bottom-right',
        }
      );
      this.notifications.push(notification);
    });
  },
  components: {},
  computed: {},
  methods: {
    toggleSidebar(){
      EventBus.$emit("toggleSidebar")
      if (this.rotation==0)this.rotation=180
      else this.rotation=0
    },
    logoff() {
      this.notifications=[];
      $("body").children().popover("hide");
      this.$socket.emit("logOff", {
        token: localStorage.getItem("jwt"),
        userId: this.user.id
      });
      var user = localStorage.getItem("user");
      localStorage.removeItem("user");
      localStorage.removeItem("jwt");
      this.updateUser();
      this.userName = null;
      this.$router.push("/");
    },
    updateUser() {
      if (localStorage.getItem("user") == null) this.user = null;
      else {
        this.user = JSON.parse(localStorage.getItem("user"));
        this.userName = this.user.name.toUpperCase();
        this.reqNotifications();
      }
    },
    keepAlive() {
      if (this.user)
        this.$socket.emit("keepAlive", {
          token: localStorage.getItem("jwt"),
          userId: this.user.id
        });
    },

    reqNotifications() {
      //console.log('req userid'+this.user.id)
      this.$socket.emit("reqNotifications", {
        userId: this.user.id,
        token: localStorage.getItem("jwt")
      });
    },
    since: function(d) {
      return moment(d).fromNow();
    },

    resFrienship(notification, res) {
      this.notifications.splice(this.notifications.indexOf(notification), 1);
      EventBus.$emit('frienshipAccepted',notification.sender)
      this.$socket.emit("resFriendship", {
        friend: notification.sender,
        response: res,
        user: this.user,
        token: localStorage.getItem("jwt")
      });
    }
  }
};
</script>
<style scoped>
@import url('https://fonts.googleapis.com/css?family=Lobster');
.text {
  font-size: 3vh !important;
}

.dropdown-menu-long {
  min-width: 40vw;
}
.title{
text-align: left;
font-family: 'Lobster', cursive;
font-weight:bold;
color: white;
text-shadow: -1px 0 #414D68, 0 1px #414D68, 1px 0 #414D68, 0 -1px #414D68, -2px 2px 0 #414D68, 2px 2px 0 #414D68, 1px 1px #414D68, 2px 2px #414D68, 3px 3px #414D68, 4px 4px #414D68, 5px 5px #414D68, 6px 6px #414D68, 7px 7px #414D68, 8px 8px #414D68, 9px 9px #414D68;
}
.rotation{
  transition: transform 1s;
  border-radius: 50%;
}
.rotated{
  transform:rotate(180deg)
}
@media (min-width: 576px) {
  .ico{
    font-size: 4vh
  }
  .icon{
    font-size: 4vh
  }
  .panel-toggler{
    display: block;
  }
 }
@media (min-width: 768px) {
  .ico{
    font-size: 4vh
  }
  .icon{
    font-size: 4vh
  }
  .panel-toggler{
    display: block;
  }
 }
@media (min-width: 992px) {
  .ico{
    font-size: 3vh

  }
  .icon{
    font-size: 2vh
  }
    .panel-toggler{
    display: none;
  }
 }
@media (min-width: 1200px) {
  .ico{
  font-size: 3vh;
  }
  .icon{
    font-size: 2vh
  }
    .panel-toggler{
    display: none;
  }
 }
</style>

